commit 389b3620239dd40569f748e2b8879da0c108c245
Author: Ondřej Váně <onry.vane@gmail.com>
Date:   Fri Apr 16 11:26:25 2021 +0200

    Adjustement of about page

diff --git a/src/main/webapp/WEB-INF/templates/about.html b/src/main/webapp/WEB-INF/templates/about.html
index 40afe44..722500b 100644
--- a/src/main/webapp/WEB-INF/templates/about.html
+++ b/src/main/webapp/WEB-INF/templates/about.html
@@ -17,15 +17,14 @@
 <div class="container">
     <h1>About</h1>
     <p>
-        Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Aenean placerat. Vivamus luctus egestas leo. Aliquam ante. Praesent in mauris eu tortor porttitor accumsan. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Fusce consectetuer risus a nunc. Proin in tellus sit amet nibh dignissim sagittis. Fusce wisi. Maecenas lorem. Integer malesuada.
-
-        Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Integer imperdiet lectus quis justo. Aenean vel massa quis mauris vehicula lacinia. Integer in sapien. Maecenas fermentum, sem in pharetra pellentesque, velit turpis volutpat ante, in pharetra metus odio a lectus. Phasellus enim erat, vestibulum vel, aliquam a, posuere eu, velit. Neque porro quisquam est, qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit, sed quia non numquam eius modi tempora incidunt ut labore et dolore magnam aliquam quaerat voluptatem. Nulla non lectus sed nisl molestie malesuada. Nulla est. Cras elementum. Quisque tincidunt scelerisque libero. Nullam rhoncus aliquam metus. Vivamus luctus egestas leo. Aliquam erat volutpat. Neque porro quisquam est, qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit, sed quia non numquam eius modi tempora incidunt ut labore et dolore magnam aliquam quaerat voluptatem. Nullam dapibus fermentum ipsum. Etiam quis quam.
-
-        Nullam feugiat, turpis at pulvinar vulputate, erat libero tristique tellus, nec bibendum odio risus sit amet ante. Phasellus enim erat, vestibulum vel, aliquam a, posuere eu, velit. Quisque tincidunt scelerisque libero. Mauris dolor felis, sagittis at, luctus sed, aliquam non, tellus. Nullam sit amet magna in magna gravida vehicula. Phasellus faucibus molestie nisl. In enim a arcu imperdiet malesuada. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Nullam lectus justo, vulputate eget mollis sed, tempor sed magna. Praesent id justo in neque elementum ultrices. In enim a arcu imperdiet malesuada. Aliquam ornare wisi eu metus. Morbi imperdiet, mauris ac auctor dictum, nisl ligula egestas nulla, et sollicitudin sem purus in lacus. Vestibulum erat nulla, ullamcorper nec, rutrum non, nonummy ac, erat. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Fusce tellus odio, dapibus id fermentum quis, suscipit id erat. Mauris metus. Nulla non lectus sed nisl molestie malesuada. Et harum quidem rerum facilis est et expedita distinctio. Ut tempus purus at lorem.
-
-        Phasellus enim erat, vestibulum vel, aliquam a, posuere eu, velit. Pellentesque sapien. Morbi leo mi, nonummy eget tristique non, rhoncus non leo. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos hymenaeos. Duis ante orci, molestie vitae vehicula venenatis, tincidunt ac pede. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum fermentum tortor id mi. Nullam sit amet magna in magna gravida vehicula. Aliquam id dolor. Donec quis nibh at felis congue commodo.
-
-        Curabitur ligula sapien, pulvinar a vestibulum quis, facilisis vel sapien. Aenean fermentum risus id tortor. Etiam sapien elit, consequat eget, tristique non, venenatis quis, ante. Aenean id metus id velit ullamcorper pulvinar. Nunc auctor. Maecenas aliquet accumsan leo. Sed convallis magna eu sem. Mauris tincidunt sem sed arcu. Fusce consectetuer risus a nunc. Nulla turpis magna, cursus sit amet, suscipit a, interdum id, felis. Fusce tellus.
+        <strong>App version:</strong> 1.0.0
+        <br>
+        <strong>Author:</strong> Ondřej Váně
+        <br>
+        <strong>E-mail:</strong> <a href="mailto:onry.vane@gmail.com">onry.vane@gmail.com</a>
+    </p>
+    <p>
+        This application is used to detect presence of anti-patterns in project management tools data. Seven selected anti-patterns are implemented in this application.
     </p>
 
 </body>